jQuery(document).ready( function() {

    jQuery('.dalilee-shipment-trigger').click( function(e) {
        e.preventDefault();
        var order_id = jQuery(this).attr("data-order_id");
        var btnAction = jQuery(this).attr("data-action");
        var nonce = jQuery(this).attr("data-nonce")
        if(btnAction == 'cancel'){
            if(!confirm('Are you sure about cancellation?')){
                return false;
            }
        }
        jQuery(this).attr('disabled', true);
        jQuery.ajax({
            type : "post",
            dataType : "json",
            url : dalileeAjax.ajaxurl,
            data : { action: 'dalilee_shipment', 'btnAction': btnAction, order_id : order_id, nonce: nonce},
            success: function(response) {
                location.reload();
            }
        });
    })
    jQuery('.dalilee-shipment-track').click(function(e){
        e.preventDefault();
        var trackingCode = jQuery(this).attr('data-tracking');
        var resultContainer = jQuery('#order_history_window');
        tb_show('Track Order', jQuery(this).attr('data-tracking-link'));
        // jQuery.ajax({
        //     type : "post",
        //     dataType : "json",
        //     url : dalileeAjax.ajaxurl,
        //     data : { action: 'dalilee_tracking', trackingCode : trackingCode},
        //     success: function(response) {
        //         if(parseInt(response.status) == 1){
        //             resultContainer.html('<p>No data2</p>');
        //         }else{
        //             resultContainer.html('<p>No data</p>');
        //         }
        //         console.log(response);
        //     }
        // });
    });
    jQuery('.dalilee_track').click(function(e){
        e.preventDefault();
        var url = decodeURIComponent(jQuery(this).attr('href').substr(1).replace(/\+/g, ' '));
        let searchParams = new URLSearchParams(url);
        tb_show('Track Order #' + searchParams.get('order_id'), url);
    });
});
jQuery( function($) {
    if (typeof dalilee_cities === 'undefined' ) {
        return false;
    }

    function getEnhancedSelectFormatString() {
        var formatString = {
            formatMatches: function( matches ) {
                if ( 1 === matches ) {
                    return wc_country_select_params.i18n_matches_1;
                }

                return wc_country_select_params.i18n_matches_n.replace( '%qty%', matches );
            },
            formatNoMatches: function() {
                return wc_country_select_params.i18n_no_matches;
            },
            formatAjaxError: function() {
                return wc_country_select_params.i18n_ajax_error;
            },
            formatInputTooShort: function( input, min ) {
                var number = min - input.length;

                if ( 1 === number ) {
                    return wc_country_select_params.i18n_input_too_short_1;
                }

                return wc_country_select_params.i18n_input_too_short_n.replace( '%qty%', number );
            },
            formatInputTooLong: function( input, max ) {
                var number = input.length - max;

                if ( 1 === number ) {
                    return wc_country_select_params.i18n_input_too_long_1;
                }

                return wc_country_select_params.i18n_input_too_long_n.replace( '%qty%', number );
            },
            formatSelectionTooBig: function( limit ) {
                if ( 1 === limit ) {
                    return wc_country_select_params.i18n_selection_too_long_1;
                }

                return wc_country_select_params.i18n_selection_too_long_n.replace( '%qty%', limit );
            },
            formatLoadMore: function() {
                return wc_country_select_params.i18n_load_more;
            },
            formatSearching: function() {
                return wc_country_select_params.i18n_searching;
            }
        };

        return formatString;
    }

    // Select2 Enhancement if it exists
    if ( $().select2 ) {
        var wc_city_select_select2 = function() {
            $( 'select.city_select:visible' ).each( function() {
                var select2_args = $.extend({
                    placeholderOption: 'first',
                    width: '100%'
                }, getEnhancedSelectFormatString() );

                $( this ).select2( select2_args );
            });
        };

        wc_city_select_select2();

        $( document.body ).bind( 'city_to_select', function() {
            wc_city_select_select2();
        });
    }

    /* City select boxes */
    // var cities_json = dalilee_cities.cities.replace( /&quot;/g, '"' );
    // var cities = $.parseJSON( cities_json );
    var cities = dalilee_cities.cities;

    $( 'body' ).on( 'country_to_state_changing', function(e, country, $container) {
        var $statebox = $container.find( '#billing_state, #shipping_state, #calc_shipping_state' );
        var state = $statebox.val();
        $( document.body ).trigger( 'state_changing', [country, state, $container ] );
    });

    $( 'body' ).on( 'change', 'select.state_select, #calc_shipping_state', function() {
        var $container = $( this ).closest( 'div' );
        var country = $container.find( '#billing_country, #shipping_country, #calc_shipping_country' ).val();
        var state = $( this ).val();

        $( document.body ).trigger( 'state_changing', [country, state, $container ] );
    });

    $( 'body' ).on( 'state_changing', function(e, country, state, $container) {
        var $citybox = $container.find( '#billing_city, #shipping_city, #calc_shipping_city' );
        if ( cities[ country ] ) {
           if ( state ) {
               state = state.replace('OM', '');
                if ( cities[ country ][ state ].length > 0 ) {
                    cityToSelect( $citybox, cities[ country ][ state ] );
                } else {
                    cityToInput( $citybox );
                }
            } else {
                disableCity( $citybox );
            }
        } else {
            cityToInput( $citybox );
        }
    });

    /* Ajax replaces .cart_totals (child of .cart-collaterals) on shipping calculator */
    if ( $( '.cart-collaterals' ).length && $( '#calc_shipping_state' ).length ) {
        var calc_observer = new MutationObserver( function() {
            $( '#calc_shipping_state' ).change();
        });
        calc_observer.observe( document.querySelector( '.cart-collaterals' ), { childList: true });
    }

    function cityToInput( $citybox ) {
        if ( $citybox.is('input') ) {
            $citybox.prop( 'disabled', false );
            return;
        }

        var input_name = $citybox.attr( 'name' );
        var input_id = $citybox.attr( 'id' );
        var placeholder = $citybox.attr( 'placeholder' );

        $citybox.parent().find( '.select2-container' ).remove();

        $citybox.replaceWith( '<input type="text" class="input-text" name="' + input_name + '" id="' + input_id + '" placeholder="' + placeholder + '" />' );
    }

    function disableCity( $citybox ) {
        $citybox.val( '' ).change();
        $citybox.prop( 'disabled', true );
    }

    function cityToSelect( $citybox, current_cities ) {
        var value = $citybox.val();

        if ( $citybox.is('input') ) {
            var input_name = $citybox.attr( 'name' );
            var input_id = $citybox.attr( 'id' );
            var placeholder = $citybox.attr( 'placeholder' );

            $citybox.replaceWith( '<select name="' + input_name + '" id="' + input_id + '" class="city_select" placeholder="' + placeholder + '"></select>' );
            //we have to assign the new object, because of replaceWith
            $citybox = $('#'+input_id);
        } else {
            $citybox.prop( 'disabled', false );
        }

        var options = '';
        jQuery.each(current_cities, function(i, r){
            options = options + '<option value="' + r.re_id + '">' + r.re_name + '</option>';
        });
        $citybox.html( '<option value="">' + dalilee_cities.i18n_select_city_text + '</option>' + options );

        if ( $('option[value="'+value+'"]', $citybox).length ) {
            $citybox.val( value ).change();
        } else {
            $citybox.val( '' ).change();
        }

        $( document.body ).trigger( 'city_to_select' );
    }
});
