<?php
/**
 * Plugin Name:       WooCommerce dalilee Shipping
 * Plugin URI:        https://www.s4d.om/hosting/store/software
 * Description:       Using dalilee API for shipping in Oman
 * Version:           1.0.0
 * Requires at least: 5.2
 * Requires PHP:      7.0
 * Author:            The Source for Development
 * Author URI:        https://www.s4d.om
 */

if ( ! defined( 'WPINC' ) ) {
    die;
}

/*
 * Check if WooCommerce is active
 */
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    include_once(__DIR__.'/plugin.php');
    Puc_v4_Factory::buildUpdateChecker(
        'https://client.ts4sd.com/updates/woocommerce-dalilee-shipping.json',
        __FILE__, //Full path to the main plugin file or functions.php.
        'woocommerce-dalilee-shipping'
    );
    add_filter('plugin_action_links_'.plugin_basename(__FILE__), function($links){
        $links[] = '<a href="'.admin_url( 'admin.php?page=wc-settings&tab=shipping&section=dalilee' ).'">'.__('Settings').'</a>';
        return $links;
    });
}else{
    add_action('admin_notices', function(){
        echo '<div class="error"><p>To use dalilee WooCommerce Shipping plugin you need to install and activate WooCommerce</p></div>';
    });
}